## freerdp2 2.0.0.4

=== libfreerdp/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# libfreerdp cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(MODULE_NAME "freerdp")
set(MODULE_PREFIX "FREERDP")

# Create imported targets for Intel IPP libraries

if(IPP_FOUND)
		foreach(ipp_lib ${IPP_LIBRARIES})
		add_library("${ipp_lib}_imported" STATIC IMPORTED)
		set_property(TARGET "${ipp_lib}_imported" PROPERTY IMPORTED_LOCATION "${IPP_LIBRARY_DIRS}/${ipp_lib}")
	endforeach()
endif()

set(LIBFREERDP_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(LIBFREERDP_SRCS "")
set(LIBFREERDP_LIBS "")
set(LIBFREERDP_INCLUDES "")
set(LIBFREERDP_DEFINITIONS "")

macro (freerdp_module_add)
		file (RELATIVE_PATH _relPath "${LIBFREERDP_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}")
		foreach (_src ${ARGN})
				if (_relPath)
						list (APPEND LIBFREERDP_SRCS "${_relPath}/${_src}")
				else()
						list (APPEND LIBFREERDP_SRCS "${_src}")
				endif()
		endforeach()
		if (_relPath)
				set (LIBFREERDP_SRCS ${LIBFREERDP_SRCS} PARENT_SCOPE)
		endif()
endmacro()

macro (freerdp_include_directory_add)
		file (RELATIVE_PATH _relPath "${LIBFREERDP_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}")
		foreach (_inc ${ARGN})
				if (IS_ABSOLUTE ${_inc})
							list (APPEND LIBFREERDP_INCLUDES "${_inc}")
				else()
					if (_relPath)
							list (APPEND LIBFREERDP_INCLUDES "${_relPath}/${_inc}")
					else()
							list (APPEND LIBFREERDP_INCLUDES "${_inc}")
					endif()
				endif()
		endforeach()
		if (_relPath)
				set (LIBFREERDP_INCLUDES ${LIBFREERDP_INCLUDES} PARENT_SCOPE)
		endif()
endmacro()

macro (freerdp_library_add)
		foreach (_lib ${ARGN})
						list (APPEND LIBFREERDP_LIBS "${_lib}")
		endforeach()
		 set (LIBFREERDP_LIBS ${LIBFREERDP_LIBS} PARENT_SCOPE)
endmacro()

macro (freerdp_definition_add)
		foreach (_define ${ARGN})
						list (APPEND LIBFREERDP_DEFINITIONS "${_define}")
		endforeach()
		 set (LIBFREERDP_DEFINITIONS ${LIBFREERDP_DEFINITIONS} PARENT_SCOPE)
endmacro()

set(${MODULE_PREFIX}_SUBMODULES
	utils
	common
	gdi
	cache
	crypto
	locale
	core)

foreach(${MODULE_PREFIX}_SUBMODULE ${${MODULE_PREFIX}_SUBMODULES})
	add_subdirectory(${${MODULE_PREFIX}_SUBMODULE})
endforeach()

## cmake source properties are only seen by targets in the same CMakeLists.txt
## therefore primitives and codecs need to be defined here

# codec
set(CODEC_SRCS
	codec/dsp.c
	codec/color.c
	codec/audio.c
	codec/planar.c
	codec/bitmap.c
	codec/interleaved.c
	codec/progressive.c
	codec/rfx_bitstream.h
	codec/rfx_constants.h
	codec/rfx_decode.c
	codec/rfx_decode.h
	codec/rfx_differential.h
	codec/rfx_dwt.c
	codec/rfx_dwt.h
	codec/rfx_encode.c
	codec/rfx_encode.h
	codec/rfx_quantization.c
	codec/rfx_quantization.h
	codec/rfx_rlgr.c
	codec/rfx_rlgr.h
	codec/rfx_types.h
	codec/rfx.c
	codec/region.c
	codec/nsc.c
	codec/nsc_encode.c
	codec/nsc_encode.h
	codec/nsc_types.h
	codec/ncrush.c
	codec/xcrush.c
	codec/mppc.c
	codec/zgfx.c
	codec/clear.c
	codec/jpeg.c
	codec/h264.c
	codec/yuv.c)

set(CODEC_SSE2_SRCS
	codec/rfx_sse2.c
	codec/rfx_sse2.h
	codec/nsc_sse2.c
	codec/nsc_sse2.h)

set(CODEC_NEON_SRCS
	codec/rfx_neon.c
	codec/rfx_neon.h)

if(WITH_SSE2)
	set(CODEC_SRCS ${CODEC_SRCS} ${CODEC_SSE2_SRCS})

	if(CMAKE_COMPILER_IS_GNUCC OR ${CMAKE_C_COMPILER_ID} STREQUAL "Clang")
		set_source_files_properties(${CODEC_SSE2_SRCS} PROPERTIES COMPILE_FLAGS "-msse2" )
	endif()

	if(MSVC)
		set_source_files_properties(${CODEC_SSE2_SRCS} PROPERTIES COMPILE_FLAGS "/arch:SSE2" )
	endif()
endif()

if (WITH_DSP_FFMPEG)
	set(CODEC_SRCS
		${CODEC_SRCS}
		codec/dsp_ffmpeg.c
		codec/dsp_ffmpeg.h)
endif (WITH_DSP_FFMPEG)

if (WITH_SOXR)
	freerdp_library_add(${SOXR_LIBRARIES})
	include_directories(${SOXR_INCLUDE_DIR})
endif(WITH_SOXR)

if(GSM_FOUND)
	freerdp_library_add(${GSM_LIBRARIES})
	include_directories(${GSM_INCLUDE_DIRS})
endif()

if(LAME_FOUND)
	freerdp_library_add(${LAME_LIBRARIES})
	include_directories(${LAME_INCLUDE_DIRS})
endif()

if(FAAD2_FOUND)
	freerdp_library_add(${FAAD2_LIBRARIES})
	include_directories(${FAAD2_INCLUDE_DIRS})
endif()

if(FAAC_FOUND)
	freerdp_library_add(${FAAC_LIBRARIES})
	include_directories(${FAAC_INCLUDE_DIRS})
endif()

if(WITH_NEON)
	set_source_files_properties(${CODEC_NEON_SRCS} PROPERTIES COMPILE_FLAGS "-mfpu=neon -Wno-unused-variable" )
	set(CODEC_SRCS ${CODEC_SRCS} ${CODEC_NEON_SRCS})
endif()

if(WITH_JPEG)
	freerdp_include_directory_add(${JPEG_INCLUDE_DIR})
	freerdp_library_add(${JPEG_LIBRARIES})
endif()

if(WITH_X264)
	set(CODEC_SRCS ${CODEC_SRCS} codec/h264_x264.c)
	freerdp_include_directory_add(${X264_INCLUDE_DIR})
	freerdp_library_add(${X264_LIBRARIES})
endif()

if(WITH_OPENH264)
	set(CODEC_SRCS ${CODEC_SRCS} codec/h264_openh264.c)
	freerdp_include_directory_add(${OPENH264_INCLUDE_DIR})
	if (NOT WITH_OPENH264_LOADING)
		freerdp_library_add(${OPENH264_LIBRARIES})
	endif (NOT WITH_OPENH264_LOADING)
endif()

if(WITH_FFMPEG)
	set(CODEC_SRCS ${CODEC_SRCS} codec/h264_ffmpeg.c)
	freerdp_include_directory_add(${FFMPEG_INCLUDE_DIRS})
	freerdp_library_add(${FFMPEG_LIBRARIES})
endif()

if(WIN32 AND WITH_MEDIA_FOUNDATION)
	set(CODEC_SRCS ${CODEC_SRCS} codec/h264_mf.c)
endif()

freerdp_module_add(${CODEC_SRCS})

if(BUILD_TESTING)
	add_subdirectory(codec/test)
endif()

# /codec

# primitives

set(PRIMITIVES_SRCS
	primitives/prim_add.c
	primitives/prim_andor.c
	primitives/prim_alphaComp.c
	primitives/prim_colors.c
	primitives/prim_copy.c
	primitives/prim_set.c
	primitives/prim_shift.c
	primitives/prim_sign.c
	primitives/prim_YUV.c
	primitives/prim_YCoCg.c
	primitives/primitives.c
	primitives/prim_internal.h)

set(PRIMITIVES_SSE2_SRCS
	primitives/prim_colors_opt.c
	primitives/prim_set_opt.c)

set(PRIMITIVES_SSE3_SRCS
	primitives/prim_add_opt.c
	primitives/prim_alphaComp_opt.c
	primitives/prim_andor_opt.c
	primitives/prim_shift_opt.c)

set(PRIMITIVES_SSSE3_SRCS
	primitives/prim_sign_opt.c
	primitives/prim_YCoCg_opt.c)

if (WITH_SSE2)
	set(PRIMITIVES_SSSE3_SRCS ${PRIMITIVES_SSSE3_SRCS}
		primitives/prim_YUV_ssse3.c)
endif()

if (WITH_NEON)
	set(PRIMITIVES_SSSE3_SRCS ${PRIMITIVES_SSSE3_SRCS}
		primitives/prim_YUV_neon.c)
endif()

set(PRIMITIVES_OPT_SRCS
	${PRIMITIVES_SSE2_SRCS}
	${PRIMITIVES_SSE3_SRCS}
	${PRIMITIVES_SSSE3_SRCS})

freerdp_definition_add(-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE})

### IPP Variable debugging
if(WITH_IPP)
	if(CMAKE_COMPILER_IS_GNUCC)
		foreach(INCLDIR ${IPP_INCLUDE_DIRS})
			set(OPTIMIZATION "${OPTIMIZATION} -I${INCLDIR}")
		endforeach(INCLDIR)
	endif()
endif()

if(WITH_SSE2)
	if(CMAKE_COMPILER_IS_GNUCC OR ${CMAKE_C_COMPILER_ID} STREQUAL "Clang")
		set_source_files_properties(${PRIMITIVES_SSE2_SRCS}
			PROPERTIES COMPILE_FLAGS "${OPTIMIZATION} -msse2")
		set_source_files_properties(${PRIMITIVES_SSE3_SRCS}
			PROPERTIES COMPILE_FLAGS "${OPTIMIZATION} -msse3")
		set_source_files_properties(${PRIMITIVES_SSSE3_SRCS}
			PROPERTIES COMPILE_FLAGS "${OPTIMIZATION} -mssse3")
	endif()

	if(MSVC)
		set_source_files_properties(${PRIMITIVES_OPT_SRCS}
			PROPERTIES COMPILE_FLAGS "${OPTIMIZATION} /arch:SSE2")
	endif()
elseif(WITH_NEON)
	if(CMAKE_COMPILER_IS_GNUCC)
		set_source_files_properties(${PRIMITIVES_OPT_SRCS}
			PROPERTIES COMPILE_FLAGS "${OPTIMIZATION} -mfpu=neon")
	endif()
	# TODO: Add MSVC equivalent
endif()

set(PRIMITIVES_SRCS ${PRIMITIVES_SRCS} ${PRIMITIVES_OPT_SRCS})

freerdp_module_add(${PRIMITIVES_SRCS})

if(IPP_FOUND)
	freerdp_include_directory_add(${IPP_INCLUDE_DIRS})
		foreach(ipp_lib ${IPP_LIBRARIES})
		freerdp_library_add("${ipp_lib}_imported")
	endforeach()
endif()

if(BUILD_TESTING AND NOT WIN32 AND NOT APPLE)
	add_subdirectory(primitives/test)
endif()


# /primitives

list(REMOVE_DUPLICATES LIBFREERDP_DEFINITIONS)
list(REMOVE_DUPLICATES LIBFREERDP_LIBS)
list(REMOVE_DUPLICATES LIBFREERDP_INCLUDES)
include_directories(${LIBFREERDP_INCLUDES})

# On windows create dll version information.
# Vendor, product and year are already set in top level CMakeLists.txt
if (WIN32)
  set (RC_VERSION_MAJOR ${FREERDP_VERSION_MAJOR})
  set (RC_VERSION_MINOR ${FREERDP_VERSION_MINOR})
  set (RC_VERSION_BUILD ${FREERDP_VERSION_REVISION})
  set (RC_VERSION_FILE "${CMAKE_SHARED_LIBRARY_PREFIX}${MODULE_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX}" )

  configure_file(
    ${CMAKE_SOURCE_DIR}/cmake/WindowsDLLVersion.rc.in
    ${CMAKE_CURRENT_BINARY_DIR}/version.rc
    @ONLY)

  set (LIBFREERDP_SRCS ${LIBFREERDP_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
endif()

add_library(${MODULE_NAME} ${LIBFREERDP_SRCS})
add_definitions(${LIBFREERDP_DEFINITIONS})

set_target_properties(${MODULE_NAME} PROPERTIES LINKER_LANGUAGE C)
set_target_properties(${MODULE_NAME} PROPERTIES OUTPUT_NAME ${MODULE_NAME}${FREERDP_VERSION_MAJOR})

if (WITH_LIBRARY_VERSIONING)
    set_target_properties(${MODULE_NAME} PROPERTIES VERSION ${FREERDP_VERSION} SOVERSION ${FREERDP_API_VERSION})
endif()


target_link_libraries(${MODULE_NAME} ${PRIVATE_KEYWORD} ${LIBFREERDP_LIBS} winpr)

install(TARGETS ${MODULE_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libraries EXPORT FreeRDPTargets)
if (WITH_DEBUG_SYMBOLS AND MSVC AND BUILD_SHARED_LIBS)
    get_target_property(OUTPUT_FILENAME ${MODULE_NAME} OUTPUT_NAME)
    install(FILES ${CMAKE_PDB_BINARY_DIR}/${OUTPUT_FILENAME}.pdb DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT symbols)
endif()

set_property(TARGET ${MODULE_NAME} PROPERTY FOLDER "FreeRDP/libfreerdp")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/freerdp.pc.in ${CMAKE_CURRENT_BINARY_DIR}/freerdp${FREERDP_VERSION_MAJOR}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/freerdp${FREERDP_VERSION_MAJOR}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

## cmake project
if(${CMAKE_VERSION} VERSION_GREATER "2.8.10")

	export(PACKAGE freerdp)

	SetFreeRDPCMakeInstallDir(FREERDP_CMAKE_INSTALL_DIR "FreeRDP${FREERDP_VERSION_MAJOR}")

	configure_package_config_file(FreeRDPConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/FreeRDPConfig.cmake
		INSTALL_DESTINATION ${FREERDP_CMAKE_INSTALL_DIR}
		PATH_VARS FREERDP_INCLUDE_DIR)

	write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/FreeRDPConfigVersion.cmake
		VERSION ${FREERDP_VERSION} COMPATIBILITY SameMajorVersion)

	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/FreeRDPConfig.cmake ${CMAKE_CURRENT_BINARY_DIR}/FreeRDPConfigVersion.cmake
		DESTINATION ${FREERDP_CMAKE_INSTALL_DIR})

	install(EXPORT FreeRDPTargets DESTINATION ${FREERDP_CMAKE_INSTALL_DIR})

endif()

=== channels/sshagent/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
# Copyright 2017 Ben Cohen
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

define_channel("sshagent")

if(WITH_CLIENT_CHANNELS)
	add_channel_client(${MODULE_PREFIX} ${CHANNEL_NAME})
endif()

=== libfreerdp/core/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# libfreerdp-core cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(MODULE_NAME "freerdp-core")
set(MODULE_PREFIX "FREERDP_CORE")

freerdp_definition_add(-DEXT_PATH="${FREERDP_EXTENSION_PATH}")

freerdp_include_directory_add(${OPENSSL_INCLUDE_DIR})
freerdp_include_directory_add(${GSS_INCLUDE_DIR})

set(${MODULE_PREFIX}_GATEWAY_DIR "gateway")

set(${MODULE_PREFIX}_GATEWAY_SRCS
	${${MODULE_PREFIX}_GATEWAY_DIR}/tsg.c
	${${MODULE_PREFIX}_GATEWAY_DIR}/tsg.h
	${${MODULE_PREFIX}_GATEWAY_DIR}/rdg.c
	${${MODULE_PREFIX}_GATEWAY_DIR}/rdg.h
	${${MODULE_PREFIX}_GATEWAY_DIR}/rpc.c
	${${MODULE_PREFIX}_GATEWAY_DIR}/rpc.h
	${${MODULE_PREFIX}_GATEWAY_DIR}/rpc_bind.c
	${${MODULE_PREFIX}_GATEWAY_DIR}/rpc_bind.h
	${${MODULE_PREFIX}_GATEWAY_DIR}/rpc_client.c
	${${MODULE_PREFIX}_GATEWAY_DIR}/rpc_client.h
	${${MODULE_PREFIX}_GATEWAY_DIR}/rpc_fault.c
	${${MODULE_PREFIX}_GATEWAY_DIR}/rpc_fault.h
	${${MODULE_PREFIX}_GATEWAY_DIR}/rts.c
	${${MODULE_PREFIX}_GATEWAY_DIR}/rts.h
	${${MODULE_PREFIX}_GATEWAY_DIR}/rts_signature.c
	${${MODULE_PREFIX}_GATEWAY_DIR}/rts_signature.h
	${${MODULE_PREFIX}_GATEWAY_DIR}/ntlm.c
	${${MODULE_PREFIX}_GATEWAY_DIR}/ntlm.h
	${${MODULE_PREFIX}_GATEWAY_DIR}/http.c
	${${MODULE_PREFIX}_GATEWAY_DIR}/http.h
	${${MODULE_PREFIX}_GATEWAY_DIR}/ncacn_http.c
	${${MODULE_PREFIX}_GATEWAY_DIR}/ncacn_http.h)

set(${MODULE_PREFIX}_SRCS
	bulk.c
	bulk.h
	activation.c
	activation.h
	gcc.c
	gcc.h
	mcs.c
	mcs.h
	nla.c
	nla.h
	nego.c
	nego.h
	info.c
	info.h
	input.c
	input.h
	license.c
	license.h
	errinfo.c
	errbase.c
	errconnect.c
	errinfo.h
	security.c
	security.h
	settings.c
	settings.h
	orders.c
	orders.h
	freerdp.c
	graphics.c
	client.c
	client.h
	server.c
	server.h
	codecs.c
	metrics.c
	capabilities.c
	capabilities.h
	certificate.c
	certificate.h
	connection.c
	connection.h
	redirection.c
	redirection.h
	autodetect.c
	autodetect.h
	heartbeat.c
	heartbeat.h
	multitransport.c
	multitransport.h
	timezone.c
	timezone.h
	rdp.c
	rdp.h
	tcp.c
	tcp.h
	proxy.c
	proxy.h
	tpdu.c
	tpdu.h
	tpkt.c
	tpkt.h
	fastpath.c
	fastpath.h
	surface.c
	surface.h
	transport.c
	transport.h
	update.c
	update.h
	message.c
	message.h
	channels.c
	channels.h
	window.c
	window.h
	listener.c
	listener.h
	peer.c
	peer.h)

set(${MODULE_PREFIX}_SRCS ${${MODULE_PREFIX}_SRCS} ${${MODULE_PREFIX}_GATEWAY_SRCS})

freerdp_module_add(${${MODULE_PREFIX}_SRCS})

if(WIN32)
	set(${MODULE_PREFIX}_LIBS ${${MODULE_PREFIX}_LIBS} ws2_32)
	freerdp_library_add(ws2_32)
endif()

freerdp_library_add(${OPENSSL_LIBRARIES})

if(WITH_GSSAPI)
	freerdp_library_add(${GSS_LIBRARIES})
endif()

if(BUILD_TESTING)
	add_subdirectory(test)
endif()

=== channels/printer/client/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

define_channel_client("printer")

set(${MODULE_PREFIX}_SRCS
	printer_main.c
	printer_main.h)

if(WITH_CUPS)
	set(${MODULE_PREFIX}_SRCS ${${MODULE_PREFIX}_SRCS}
		printer_cups.c
		printer_cups.h)
		
	include_directories(${CUPS_INCLUDE_DIR})
	add_definitions(-DWITH_CUPS)
endif()

if(WIN32 AND NOT UWP)
	set(${MODULE_PREFIX}_SRCS ${${MODULE_PREFIX}_SRCS}
		printer_win.c
		printer_win.h)
endif()

add_channel_client_library(${MODULE_PREFIX} ${MODULE_NAME} ${CHANNEL_NAME} TRUE "DeviceServiceEntry")



set(${MODULE_PREFIX}_LIBS ${${MODULE_PREFIX}_LIBS} winpr freerdp)

if(WITH_CUPS)
	set(${MODULE_PREFIX}_LIBS ${${MODULE_PREFIX}_LIBS} ${CUPS_LIBRARIES})
endif()

target_link_libraries(${MODULE_NAME} ${${MODULE_PREFIX}_LIBS})


if (WITH_DEBUG_SYMBOLS AND MSVC AND NOT BUILTIN_CHANNELS AND BUILD_SHARED_LIBS)
	install(FILES ${CMAKE_BINARY_DIR}/${MODULE_NAME}.pdb DESTINATION ${FREERDP_ADDIN_PATH} COMPONENT symbols)
endif()

set_property(TARGET ${MODULE_NAME} PROPERTY FOLDER "Channels/${CHANNEL_NAME}/Client")

=== debian/changelog ===
freerdp2 (2.0.0.4-1+dde) unstable; urgency=low

  * ['Autobuild release-candidate: 08a493f4d24c72a55d13d0166860cb68c06070f3']

 -- shuttle <shuttle@deepin.com>  Thu, 29 Oct 2020 12:35:01 +0000

## freerdp2 2.0.0.5

=== server/Windows/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP Windows Server cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(MODULE_NAME "wfreerdp-server")
set(MODULE_PREFIX "FREERDP_SERVER_WINDOWS")

include_directories(.)

set(${MODULE_PREFIX}_SRCS
	wf_update.c
	wf_update.h
	wf_dxgi.c
	wf_dxgi.h
	wf_input.c
	wf_input.h
	wf_interface.c
	wf_interface.h
	wf_mirage.c
	wf_mirage.h
	wf_peer.c
	wf_peer.h
	wf_settings.c
	wf_settings.h
	wf_info.c
	wf_info.h)
	
if(CHANNEL_RDPSND AND NOT WITH_RDPSND_DSOUND)
	set(${MODULE_PREFIX}_SRCS
		${${MODULE_PREFIX}_SRCS}
		wf_rdpsnd.c
		wf_rdpsnd.h
		wf_wasapi.c
		wf_wasapi.h
		)
endif()

if(CHANNEL_RDPSND AND WITH_RDPSND_DSOUND)
	set(${MODULE_PREFIX}_SRCS
		${${MODULE_PREFIX}_SRCS}
		wf_rdpsnd.c
		wf_rdpsnd.h
		wf_directsound.c
		wf_directsound.h
		)
endif()

# On windows create dll version information.
# Vendor, product and year are already set in top level CMakeLists.txt
set (RC_VERSION_MAJOR ${FREERDP_VERSION_MAJOR})
set (RC_VERSION_MINOR ${FREERDP_VERSION_MINOR})
set (RC_VERSION_BUILD ${FREERDP_VERSION_REVISION})
if(WITH_SERVER_INTERFACE)
  set (RC_VERSION_FILE "${CMAKE_SHARED_LIBRARY_PREFIX}${MODULE_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX}" )
else()
  set (RC_VERSION_FILE "${MODULE_NAME}${CMAKE_EXECUTABLE_SUFFIX}" )
endif()

configure_file(
  ${CMAKE_SOURCE_DIR}/cmake/WindowsDLLVersion.rc.in
  ${CMAKE_CURRENT_BINARY_DIR}/version.rc
  @ONLY)

set (${MODULE_PREFIX}_SRCS ${${MODULE_PREFIX}_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/version.rc)

if(WITH_SERVER_INTERFACE)
	add_library(${MODULE_NAME} ${${MODULE_PREFIX}_SRCS})
  if (WITH_LIBRARY_VERSIONING)
  	set_target_properties(${MODULE_NAME} PROPERTIES VERSION ${FREERDP_VERSION} SOVERSION ${FREERDP_API_VERSION})
  endif()
  
else()
	set(${MODULE_PREFIX}_SRCS ${${MODULE_PREFIX}_SRCS} cli/wfreerdp.c cli/wfreerdp.h)
	add_executable(${MODULE_NAME} ${${MODULE_PREFIX}_SRCS})
endif()


if(CMAKE_WINDOWS_VERSION STREQUAL "WIN8")
	set(${MODULE_PREFIX}_LIBS ${${MODULE_PREFIX}_LIBS} d3d11 dxgi dxguid)
endif()

set(${MODULE_PREFIX}_LIBS ${${MODULE_PREFIX}_LIBS} dsound)
set(${MODULE_PREFIX}_LIBS ${${MODULE_PREFIX}_LIBS} freerdp-server freerdp)

target_link_libraries(${MODULE_NAME} ${${MODULE_PREFIX}_LIBS})

if(WITH_SERVER_INTERFACE)
	install(TARGETS ${MODULE_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libraries)

	if (WITH_DEBUG_SYMBOLS AND MSVC AND BUILD_SHARED_LIBS)
		install(FILES ${CMAKE_BINARY_DIR}/${MODULE_NAME}.pdb DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT symbols)
	endif()
else()
	install(TARGETS ${MODULE_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT server)

	if (WITH_DEBUG_SYMBOLS AND MSVC)
		install(FILES ${CMAKE_BINARY_DIR}/${MODULE_NAME}.pdb DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT symbols)
	endif()
endif()

if(WITH_SERVER_INTERFACE)
	add_subdirectory(cli)
endif()

set_property(TARGET ${MODULE_NAME} PROPERTY FOLDER "Server/Windows")

=== winpr/libwinpr/heap/CMakeLists.txt ===
# WinPR: Windows Portable Runtime
# libwinpr-heap cmake build script
#
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

winpr_module_add(heap.c)

=== winpr/libwinpr/rpc/CMakeLists.txt ===
# WinPR: Windows Portable Runtime
# libwinpr-rpc cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

winpr_module_add(
	rpc.c
	ndr.c
	ndr_array.c
	ndr_array.h
	ndr_context.c
	ndr_context.h
	ndr_correlation.c
	ndr_correlation.h
	ndr_pointer.c
	ndr_pointer.h
	ndr_private.c
	ndr_private.h
	ndr_simple.c
	ndr_simple.h
	ndr_string.c
	ndr_string.h
	ndr_structure.c
	ndr_structure.h
	ndr_union.c
	ndr_union.h
	midl.c)

winpr_include_directory_add(${OPENSSL_INCLUDE_DIR})

winpr_library_add(${OPENSSL_LIBRARIES})

if(WIN32)
	winpr_library_add(ws2_32 rpcrt4)
endif()

=== debian/changelog ===
freerdp2 (2.0.0.5-deepin1) unstable; urgency=medium

  * fix CVE-2021-41160.

 -- liaoyuan <liaoyuan@uniontech.com>  Tue, 29 Nov 2022 09:19:40 +0800

freerdp2 (2.0.0.3-1+dde) buster; urgency=medium

  * Non-maintainer upload.
  * fix CVE-2020-13398 CVE-2020-13396 CVE-2020-11019 CVE-2020-11098 CVE-2020-13397 CVE-2020-11086 CVE-2020-11087 CVE-2020-11088 CVE-2020-11095 CVE-2020-4033 CVE-2020-11038


 -- zhouzilong <zhouzilong@uniontech.com>  Fri, 11 Sep 2020 17:56:20 +0800

## freerdp2 2.1.1+dfsg1

=== debian/changelog ===
freerdp2 (2.1.1+dfsg1-0ubuntu0.19.10.1) eoan-security; urgency=medium

  * Updated to 2.1.1 to fix multiple security issues.
    - debian/rules: set WITH_PROXY=OFF for now.
    - debian/control: add libcairo2-dev to Build-Depends.
    - debian/rules: set WITH_CAIRO=ON.
    - debian/*symbols: updated for new version.
    - CVE-2019-17177, CVE-2020-11042, CVE-2020-11044, CVE-2020-11045,
      CVE-2020-11046, CVE-2020-11047, CVE-2020-11048, CVE-2020-11049,
      CVE-2020-11058, CVE-2020-11521, CVE-2020-11522, CVE-2020-11523,
      CVE-2020-11524, CVE-2020-11525, CVE-2020-11526, CVE-2020-13396,
      CVE-2020-13397, CVE-2020-13398

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 25 May 2020 12:58:15 -0400

=== debian/control ===
Source: freerdp2
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Remote Maintainers <debian-remote@lists.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Bernhard Miklautz <bernhard.miklautz@shacknet.at>,
Build-Depends:
 cmake,
 debhelper-compat (= 12),
 docbook-xsl,
 dpkg-dev (>= 1.16.1.1),
 libasound2-dev,
 libavcodec-dev,
 libavutil-dev,
 libcairo2-dev,
 libcups2-dev,
 libdbus-glib-1-dev,
 libgsm1-dev,
 libgstreamer-plugins-base1.0-dev,
 libgstreamer1.0-dev,
 libjpeg-dev,
 libpcsclite-dev,
 libpulse-dev,
 libssl-dev,
 libsystemd-dev [linux-any],
 libudev-dev [linux-any],
 libusb-1.0-0-dev [linux-any],
 libwayland-dev [linux-any],
 libx11-dev,
 libxcursor-dev,
 libxdamage-dev,
 libxext-dev,
 libxfixes-dev,
 libxi-dev,
 libxinerama-dev,
 libxkbcommon-dev,
 libxkbfile-dev,
 libxrandr-dev,
 libxrender-dev,
 libxtst-dev,
 libxv-dev,
 pkg-config,
 uuid-dev,
 xmlto,
 xsltproc,
 libicu-dev
Standards-Version: 4.3.0
Homepage: http://www.freerdp.com/
Vcs-Browser: https://salsa.debian.org/debian-remote-team/freerdp2
Vcs-Git: https://salsa.debian.org/debian-remote-team/freerdp2.git

Package: freerdp2-x11
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 freerdp,
Replaces:
 freerdp-x11,
Conflicts:
 freerdp-x11,
Description: RDP client for Windows Terminal Services (X11 client)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 Currently, the FreeRDP client supports the following Windows Versions:
 .
  * Windows NT Server
  * Windows 2000 Terminal Server
  * Windows XP
  * Windows 2003 Server
  * Windows Vista
  * Windows 2008/2008r2/2011SBS Server
  * Windows 7
  * Windows 2012/2012r2 Server
  * Windows 8
  * Windows 10
 .
 This package contains the X11 based client.

Package: libfreerdp2-2
Architecture: any
Section: libs
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libfreerdp2 (<< 2.0.0~git20170725.1.1648deb+dfsg1-1~),
Replaces:
 libfreerdp2 (<< 2.0.0~git20170725.1.1648deb+dfsg1-1~),
Multi-Arch: same
Suggests:
 freerdp2-x11,
Description: Free Remote Desktop Protocol library (core library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shared library with all core functionality.

Package: libfreerdp-client2-2
Architecture: any
Section: libs
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libfreerdp-client2 (<< 2.0.0~git20170725.1.1648deb+dfsg1-1~),
Replaces:
 libfreerdp-client2 (<< 2.0.0~git20170725.1.1648deb+dfsg1-1~),
Multi-Arch: same
Description: Free Remote Desktop Protocol library (client library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shared library for common client functionality.

Package: libfreerdp-server2-2
Architecture: any
Section: libs
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libfreerdp-server2 (<< 2.0.0~git20170725.1.1648deb+dfsg1-1~),
Replaces:
 libfreerdp-server2 (<< 2.0.0~git20170725.1.1648deb+dfsg1-1~),
Multi-Arch: same
Description: Free Remote Desktop Protocol library (server library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shared library with common server functionality.

Package: libwinpr2-2
Architecture: any
Section: libs
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libwinpr2 (<< 2.0.0~git20170725.1.1648deb+dfsg1-1~),
Replaces:
 libwinpr2 (<< 2.0.0~git20170725.1.1648deb+dfsg1-1~),
Multi-Arch: same
Suggests:
 freerdp2-x11,
Description: Windows Portable Runtime library
 WinPR is a spin-off project of FreeRDP which aims at providing a portable
 implementation of important portions of the Windows API. Just like FreeRDP,
 WinPR is released under the Apache license. Unlike Wine, WinPR does not provide
 binary compatibility, and does not require applications to be built for
 Windows. Instead, WinPR provides API compatibility for applications targeting
 non-Windows environments. When on Windows, the original native API is being
 used instead of the equivalent WinPR implementation, without having to modify
 the code using it.
 .
 This package contains the WinPR shared library.

Package: libwinpr-tools2-2
Architecture: any
Section: libs
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libwinpr-tools2 (<< 2.0.0~git20170725.1.1648deb+dfsg1-1~),
Replaces:
 libwinpr-tools2 (<< 2.0.0~git20170725.1.1648deb+dfsg1-1~),
Multi-Arch: same
Description: Windows Portable Runtime Tools library
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shared library for Windows Portable Runtime
 utilities and tools.

Package: libwinpr2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libssl-dev,
 libwinpr-tools2-2 (= ${binary:Version}),
 libwinpr2-2 (= ${binary:Version}),
 ${misc:Depends},
Description: Windows Portable Runtime library (development files)
 WinPR is a spin-off project of FreeRDP which aims at providing a portable
 implementation of important portions of the Windows API. Just like FreeRDP,
 WinPR is released under the Apache license. Unlike Wine, WinPR does not provide
 binary compatibility, and does not require applications to be built for
 Windows. Instead, WinPR provides API compatibility for applications targeting
 non-Windows environments. When on Windows, the original native API is being
 used instead of the equivalent WinPR implementation, without having to modify
 the code using it.
 .
 This package contains the WinPR development files.

Package: freerdp2-dev
Section: devel
Architecture: any
Depends:
 libfreerdp-client2-2 (= ${binary:Version}),
 libfreerdp-server2-2 (= ${binary:Version}),
 libfreerdp-shadow-subsystem2-2 (= ${binary:Version}),
 libfreerdp-shadow2-2 (= ${binary:Version}),
 libfreerdp2-2 (= ${binary:Version}),
 libwinpr2-dev (= ${binary:Version}),
 winpr-utils (= ${binary:Version}),
 ${misc:Depends},
Description: Free Remote Desktop Protocol library (development files)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the FreeRDP development files.

Package: winpr-utils
Multi-Arch: foreign
Section: utils
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Windows Portable Runtime library command line utilities
 WinPR is a spin-off project of FreeRDP which aims at providing a portable
 implementation of important portions of the Windows API. Just like FreeRDP,
 WinPR is released under the Apache license. Unlike Wine, WinPR does not provide
 binary compatibility, and does not require applications to be built for
 Windows. Instead, WinPR provides API compatibility for applications targeting
 non-Windows environments. When on Windows, the original native API is being
 used instead of the equivalent WinPR implementation, without having to modify
 the code using it.
 .
 This package contains WinPR command line utils (winpr-hash, winpr-makecert).

Package: libfreerdp-shadow2-2
Architecture: any
Section: libs
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libfreerdp-shadow2 (<< 2.0.0~git20170725.1.1648deb+dfsg1-1~),
Replaces:
 libfreerdp-shadow2 (<< 2.0.0~git20170725.1.1648deb+dfsg1-1~),
Multi-Arch: same
Description: FreeRDP Remote Desktop Protocol shadow libraries
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shadow libraries.

Package: libfreerdp-shadow-subsystem2-2
Architecture: any
Section: libs
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libfreerdp-shadow2 (<< 2.0.0~git20170725.1.1648deb+dfsg1-1~),
Replaces:
 libfreerdp-shadow2 (<< 2.0.0~git20170725.1.1648deb+dfsg1-1~),
Multi-Arch: same
Description: FreeRDP Remote Desktop Protocol shadow subsystem libraries
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shadow subsystem libraries.

Package: freerdp2-shadow-x11
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 freerdp,
Description: FreeRDP x11 shadowing server
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains a "shadowing" server that can be used to
 share an already started X11 DISPLAY.

Package: libuwac0-0
Architecture: linux-any
Section: libs
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libuwac0 (<< 2.0.0~git20170725.1.1648deb+dfsg1-1~),
Replaces:
 libuwac0 (<< 2.0.0~git20170725.1.1648deb+dfsg1-1~),
Multi-Arch: same
Description: Using wayland as a client library
 Using wayland as a client (uwac) is a library to provide common
 functionality for wayland clients.
 .
 This package contains the using wayland as a client library.

Package: libuwac0-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends:
 libuwac0-0 (= ${binary:Version}),
 ${misc:Depends},
Description: Using wayland as a client (development files)
 Using wayland as a client (uwac) is a library to provide common
 functionality for wayland clients.
 .
 This package contains the libuwac development files

Package: freerdp2-wayland
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: RDP client for Windows Terminal Services (wayland client)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 Currently, the FreeRDP clients supports the following Windows Versions:
 .
  * Windows NT Server
  * Windows 2000 Terminal Server
  * Windows XP
  * Windows 2003 Server
  * Windows Vista
  * Windows 2008/2008r2/2011SBS Server
  * Windows 7
  * Windows 2012/2012r2 Server
  * Windows 8
  * Windows 10
 .
 This package contains the wayland based client.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

DEB_HOST_ARCH?=$(shell dpkg-architecture -qDEB_HOST_ARCH)
ifneq (,$(filter armel,$(DEB_HOST_ARCH)))
WITH_NEON = -DWITH_NEON=OFF
else
WITH_NEON =
endif

DEB_HOST_ARCH_OS?=$(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
ifeq (,$(filter linux, $(DEB_HOST_ARCH_OS)))
WITH_WAYLAND = -DWITH_WAYLAND=OFF
WITH_LIBSYSTEMD = -DWITH_LIBSYSTEMD=OFF
WITH_ALSA = -DWITH_ALSA=OFF
else
WITH_WAYLAND =
WITH_LIBSYSTEMD =
WITH_ALSA =
endif

NULL =

DEB_HOST_ARCH_OS?=$(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
ifneq (,$(filter linux,$(DEB_HOST_ARCH_OS)))
LINUX_URBDRC_CLIENT = -DCHANNEL_URBDRC=ON \
                      -DCHANNEL_URBDRC_CLIENT=ON \
                      $(NULL)
else
LINUX_URBDRC_CLIENT = -DCHANNEL_URBDRC=OFF \
                      -DCHANNEL_URBDRC_CLIENT=OFF \
                      $(NULL)
endif

DEB_CMAKE_EXTRA_FLAGS :=  -DCMAKE_INSTALL_INCLUDEDIR=include/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH) \
                          -DCMAKE_SKIP_RPATH=FALSE \
                          -DCMAKE_SKIP_INSTALL_RPATH=TRUE \
                          -DWITH_PULSE=ON \
                          ${WITH_ALSA} \
                          -DWITH_CHANNELS=ON \
                          -DBUILTIN_CHANNELS=ON \
                          -DWITH_CUPS=ON \
                          -DWITH_PCSC=ON \
                          -DWITH_JPEG=ON \
                          -DWITH_GSTREAMER_0_10=OFF \
                          -DWITH_GSTREAMER_1_0=ON \
                          $(LINUX_URBDRC_CLIENT) \
                          -DWITH_SERVER=ON \
			  -DWITH_PROXY=OFF \
			  -DWITH_CAIRO=ON \
                          -DBUILD_TESTING=OFF \
                          -DCMAKE_BUILD_TYPE=RELWITHDEBINFO \
                          $(WITH_WAYLAND) \
                          $(WITH_LIBSYSTEMD) \
                          -DWITH_CLIENT_INTERFACE=OFF \
                          -DWITH_ICU=ON \
                          $(WITH_NEON) \
                          $(NULL)

# Ubuntu can't have ffmpeg in main
ifeq ($(shell dpkg-vendor --is Ubuntu && echo yes),yes)
DEB_CMAKE_EXTRA_FLAGS += -DWITH_FFMPEG=OFF -DWITH_GSM=OFF
else
DEB_CMAKE_EXTRA_FLAGS += -DWITH_GSM=ON
endif

%:
	dh $@

.PHONY: override_dh_auto_configure override_dh_install override_dh_strip
override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CMAKE_EXTRA_FLAGS)

override_dh_install:
	rm -rf debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.a
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/freerdp/
	dh_install

override_dh_missing:
	dh_missing --fail-missing

override_dh_strip:
	dh_strip -plibfreerdp2-2 --dbgsym-migration='libfreerdp2-dbg (<< 2.0.0~git20161130.1.e60d0d5+dfsg1-1~exp1~)'
	dh_strip -plibfreerdp-server2-2 --dbgsym-migration='libfreerdp-server2-dbg (<< 2.0.0~git20161130.1.e60d0d5+dfsg1-1~exp1~)'
	dh_strip -plibfreerdp-shadow2-2 --dbgsym-migration='libfreerdp-shadow2-dbg (<< 2.0.0~git20161130.1.e60d0d5+dfsg1-1~exp1~)'
	dh_strip -plibfreerdp-shadow-subsystem2-2 --dbgsym-migration='libfreerdp-shadow2-dbg (<< 2.0.0~git20161130.1.e60d0d5+dfsg1-1~exp1~)'
	dh_strip -plibfreerdp-client2-2 --dbgsym-migration='libfreerdp-client2-dbg (<< 2.0.0~git20161130.1.e60d0d5+dfsg1-1~exp1~)'
	dh_strip -plibwinpr2-2 --dbgsym-migration='libwinpr2-dbg (<< 2.0.0~git20161130.1.e60d0d5+dfsg1-1~exp1~)'
	dh_strip -plibwinpr-tools2-2 --dbgsym-migration='libwinpr-tools2-dbg (<< 2.0.0~git20161130.1.e60d0d5+dfsg1-1~exp1~)'
	dh_strip -pfreerdp2-x11 --dbgsym-migration='freerdp2-x11-dbg (<< 2.0.0~git20161130.1.e60d0d5+dfsg1-1~exp1~)'
	dh_strip -pfreerdp2-shadow-x11 --dbgsym-migration='freerdp2-shadow-x11-dbg (<< 2.0.0~git20161130.1.e60d0d5+dfsg1-1~exp1~)'
	dh_strip -pwinpr-utils --dbgsym-migration='winpr-utils-dbg (<< 2.0.0~git20161130.1.e60d0d5+dfsg1-1~exp1~)'
	dh_strip -pfreerdp2-wayland --dbgsym-migration='freerdp2-wayland-dbg (<< 2.0.0~git20161130.1.e60d0d5+dfsg1-1~exp1~)'
	dh_strip -plibuwac0-0 --dbgsym-migration='libuwac0-dbg (<< 2.0.0~git20161130.1.e60d0d5+dfsg1-1~exp1~)'

include /usr/share/dpkg/pkg-info.mk

PKD   = $(word 1,$(abspath $(dir $(MAKEFILE_LIST))))
PKG   = $(DEB_SOURCE)
UVER  = $(shell echo $(DEB_VERSION) | cut -d "-" -f1)
DTYPE = +dfsg1
VER  ?= $(subst $(DTYPE),,$(UVER))

UURL = git://github.com/FreeRDP/FreeRDP.git
UREV = $(shell echo $(VER) | cut -d"." -f5)

## http://wiki.debian.org/onlyjob/get-orig-source
.PHONY: get-orig-source
get-orig-source: $(PKG)_$(VER)$(DTYPE).orig.tar.xz $(info I: $(PKG)_$(VER)$(DTYPE))
	@

$(PKG)_$(VER)$(DTYPE).orig.tar.xz: $(info I: GIT Revision=$(UREV))
	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
	@echo "# Downloading..."
	git clone $(UURL) $(PKG)-$(VER) \
	    || $(RM) -r $(PKG)-$(VER)
	cd $(PKG)-$(VER) \
	    && git checkout "$(UREV)" \
	    && ( echo "# Generating ChangeLog..." \
	       ; git --no-pager log --format="%ai %aN (%h) %n%n%x09*%w(68,0,10) %s%n" > ChangeLog \
	       ; touch -d "$$(git log -1 --format='%ci')" ChangeLog) \
	    && echo "# Setting times..." \
	    && for F in $$(git ls-tree -r --name-only HEAD); do touch --no-dereference -d "$$(git log -1 --format="%ai" -- $$F)" "$$F"; done \
	    && echo "# Cleaning-up..." \
	    && rm -rf \
	        client/Android/ \
	        client/iOS/ \
	        client/Mac/ \
	        client/Windows/ \
	        scripts/OpenSSL-DownloadAndBuild.command \
	        winpr/libwinpr/crt/utf.* \
	    && $(RM) -r .git .git* \
	    && echo "$(UREV)+debian" > .source_version
	@echo "# Packing..."
	find -L "$(PKG)-$(VER)" -xdev -type f -print | sort \
	    | XZ_OPT="-6v" tar -caf "../$(PKG)_$(VER)$(DTYPE).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
	    && $(RM) -r "$(PKG)-$(VER)"

## freerdp2 2.2.0%2Bdfsg1

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Section: x11
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Remote Maintainers <debian-remote@lists.debian.org>
+XSBC-Original-Maintainer: Debian Remote Maintainers <pkg-remote-team@lists.alioth.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
  Bernhard Miklautz <bernhard.miklautz@shacknet.at>,
 Build-Depends:
  cmake,
- debhelper-compat (= 12),
+ debhelper (>= 11~),
  docbook-xsl,
  dpkg-dev (>= 1.16.1.1),
  libasound2-dev,
@@ -46,7 +46,7 @@
  xmlto,
  xsltproc,
  libicu-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.1.3
 Homepage: http://www.freerdp.com/
 Vcs-Browser: https://salsa.debian.org/debian-remote-team/freerdp2
 Vcs-Git: https://salsa.debian.org/debian-remote-team/freerdp2.git

=== debian/rules ===
--- 
+++ 
@@ -79,10 +79,7 @@
 override_dh_install:
 	rm -rf debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.a
 	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/freerdp/
-	dh_install
-
-override_dh_missing:
-	dh_missing --fail-missing
+	dh_install --fail-missing
 
 override_dh_strip:
 	dh_strip -plibfreerdp2-2 --dbgsym-migration='libfreerdp2-dbg (<< 2.0.0~git20161130.1.e60d0d5+dfsg1-1~exp1~)'
@@ -133,9 +130,7 @@
 	        client/Mac/ \
 	        client/Windows/ \
 	        scripts/OpenSSL-DownloadAndBuild.command \
-	        winpr/libwinpr/crt/utf.* \
-	    && $(RM) -r .git .git* \
-	    && echo "$(UREV)+debian" > .source_version
+	    && $(RM) -r .git .git*
 	@echo "# Packing..."
 	find -L "$(PKG)-$(VER)" -xdev -type f -print | sort \
 	    | XZ_OPT="-6v" tar -caf "../$(PKG)_$(VER)$(DTYPE).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
